import type { JSX } from '../../stencil-public-runtime';
import type { ButtonProps, FocusableElement, HideErrorPropType, IconsHorizontalPropType, IdPropType, InputDateAPI, InputDateStates, InputDateType, InputTypeOnDefault, InputTypeOnOff, Iso8601, LabelWithExpertSlotPropType, MsgPropType, NamePropType, ReadOnlyPropType, ShortKeyPropType, Stringified, SuggestionsPropType, SyncValueBySelectorPropType, TooltipAlignPropType } from '../../schema';
export declare class KolInputDate implements InputDateAPI, FocusableElement {
    private readonly host?;
    private inputRef?;
    private _initialValueType;
    private readonly catchRef;
    getValue(): Promise<string | Date | undefined>;
    focus(): Promise<void>;
    kolFocus(): Promise<void>;
    reset(): Promise<void>;
    private setInitialValueType;
    private remapValue;
    private readonly onChange;
    private readonly onInput;
    private readonly onKeyDown;
    render(): JSX.Element;
    private readonly controller;
    _accessKey?: string;
    _alert?: boolean;
    _autoComplete?: InputTypeOnOff;
    _disabled?: boolean;
    _error?: string;
    _hideError?: boolean;
    _hideLabel?: boolean;
    _hint?: string;
    _icons?: IconsHorizontalPropType;
    _id?: IdPropType;
    _label: LabelWithExpertSlotPropType;
    _max?: Iso8601 | Date;
    _min?: Iso8601 | Date;
    _msg?: Stringified<MsgPropType>;
    _name?: NamePropType;
    _on?: InputTypeOnDefault;
    _readOnly?: boolean;
    _required?: boolean;
    _shortKey?: ShortKeyPropType;
    _smartButton?: Stringified<ButtonProps>;
    _suggestions?: SuggestionsPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _step?: number;
    _tabIndex?: number;
    _tooltipAlign?: TooltipAlignPropType;
    _touched?: boolean;
    _type: InputDateType;
    _value?: Iso8601 | Date | null;
    state: InputDateStates;
    private inputHasFocus;
    constructor();
    private showAsAlert;
    validateAccessKey(value?: string): void;
    validateAlert(value?: boolean): void;
    validateAutoComplete(value?: InputTypeOnOff): void;
    validateDisabled(value?: boolean): void;
    validateError(value?: string): void;
    validateHideError(value?: HideErrorPropType): void;
    validateHideLabel(value?: boolean): void;
    validateHint(value?: string): void;
    validateIcons(value?: IconsHorizontalPropType): void;
    validateId(value?: string): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateMax(value?: Iso8601 | Date): void;
    validateMin(value?: Iso8601 | Date): void;
    validateMsg(value?: Stringified<MsgPropType>): void;
    validateName(value?: string): void;
    validateOn(value?: InputTypeOnDefault): void;
    validateReadOnly(value?: ReadOnlyPropType): void;
    validateRequired(value?: boolean): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSmartButton(value?: ButtonProps | string): void;
    validateSuggestions(value?: SuggestionsPropType): void;
    validateStep(value?: number): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTabIndex(value?: number): void;
    validateTouched(value?: boolean): void;
    validateType(value?: InputDateType): void;
    validateValue(value?: Iso8601 | Date | null): void;
    componentWillLoad(): void;
}
